//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#include <math.hpp>
#pragma hdrstop
#include "Checker.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TCheckerForm *CheckerForm;
//---------------------------------------------------------------------------
__fastcall TCheckerForm::TCheckerForm(TComponent* Owner) : TForm(Owner)
{
 this->IDCodeLength = 10; //ҦrTw׬O10
 this->StartingBaseValue = 10;    //ytsX򩳭
}
//---------------------------------------------------------------------------

void __fastcall TCheckerForm::FormCreate(TObject *Sender)
{
 int Count;

 this->IDVerifiedLabeledEdit->MaxLength = this->IDCodeLength; 
 this->HouseHoldPlacesComboBox->Clear();
 for ( Count = 0 ; HouseHoldPlaces[Count] != NULL ; ++Count )
       this->HouseHoldPlacesComboBox->Items->Add(HouseHoldPlaces[Count]);
 this->HouseHoldPlacesComboBox->ItemIndex = 0;
}
//---------------------------------------------------------------------------

void __fastcall TCheckerForm::IDVerifiedLabeledEditKeyPress(TObject *Sender, char &Key)
{
 char TempKey;

 TempKey = toupper(Key);
 if ( ( TempKey >= 'A' && TempKey <= 'Z' ) || ( TempKey >= '0' && TempKey <= '9' ) || TempKey == char(8) )
        return;
 else
        Key = 0;
}

//---------------------------------------------------------------------------
bool __fastcall TCheckerForm::VerifyIDFormat(char *IDCode)
{
 bool IsLegal = true;
 int Count;

 if ( ! ( ( IDCode[0] >= 'A' ) && ( IDCode[0] <= 'Z' ) ) )
      return ( ! IsLegal );

 for ( Count = 1 ; Count < this->IDCodeLength ; ++Count )
 {
  if ( ! ( ( IDCode[Count] >= '0' ) && ( IDCode[Count] <= '9' ) ) )
      return ( ! IsLegal );
 }

 return IsLegal;
}

//---------------------------------------------------------------------------
/* HU`ۡuʬv
http://zh.wikipedia.org/wiki/%E4%B8%AD%E8%8F%AF%E6%B0%91%E5%9C%8B%E5%9C%8B%E6%B0%91%E8%BA%AB%E5%88%86%E8%AD%89
إҦ۱qˬdXHӡAҬYXTʡCCӭ^rG줸ơACUCOG
r줸 + rk줸 * 9 + ʧOX * 8 + _]HUҦP^ĤG줸Ʀr * 7 + ĤT줸Ʀr * 6 + ĥ|줸Ʀr * 5 + Ĥ줸Ʀr * 4 + Ĥ줸Ʀr * 3 + ĤC줸Ʀr * 2 + ĤK줸Ʀr * 1
10WzGӦƴNOˬdXCҦpAA234567893A10Ao 1 + 0*9 + 2*8 + 3*7 + 4*6 + 5*5 + 6*4 + 7*3 + 8*2 + 9*1 = 157C10-7=3AҥHˬdXO3ATCϤAA234567890NOĦrjpC
*/
bool __fastcall TCheckerForm::VerifyIDCode(char *IDCode)
{
 bool IsLegal = false, Found=false;
 char TempHouseHoldCode = IDCode[0], TempHouseHoldChar[3];
 int Count, HouseHoldNumber, LeftHouseHoldNumber, RightHouseHoldNumber, SumUp, CheckSum = int(IDCode[9]) - int('0');

 if ( ! ( ( TempHouseHoldCode >= 'A' ) && ( TempHouseHoldCode <= 'Z' ) ) )
      return IsLegal;

 for ( Count = 0 ; HouseHoldCodes[Count] ; ++Count )
 {
  if ( HouseHoldCodes[Count] == TempHouseHoldCode )
  {
   HouseHoldNumber = this->StartingBaseValue + Count;
   Found = true;
   break;
  }
 }
 if ( ! Found )
      return IsLegal;

 sprintf(TempHouseHoldChar,"%02d",HouseHoldNumber);
 LeftHouseHoldNumber = int(TempHouseHoldChar[0]) - int('0');
 RightHouseHoldNumber = int(TempHouseHoldChar[1]) - int('0');
 SumUp = LeftHouseHoldNumber + ( RightHouseHoldNumber * 9 );
 for ( Count = 1 ; Count <= 8 ; ++Count )
       SumUp += ( int(IDCode[Count]) - int('0') ) * ( 9 - Count );
 SumUp += CheckSum;
 if ( ( SumUp % 10 ) == 0 )
        IsLegal = true;
 return IsLegal;
}

//---------------------------------------------------------------------------
void __fastcall TCheckerForm::GenerateIDCode(char *IDCode)
{
 char TempHouseHoldChar[3],CheckSumChar;
 int Count, RandNumber, HouseHoldNumber, LeftHouseHoldNumber, RightHouseHoldNumber, SumUp, CheckSum;

 IDCode[0] = HouseHoldCodes[this->HouseHoldPlacesComboBox->ItemIndex];
 IDCode[1] = ( this->MaleRadioButton->Checked ) ? '1' : '2';

 for ( Count = 0 ; HouseHoldCodes[Count] ; ++Count )
 {
  if ( HouseHoldCodes[Count] == HouseHoldCodes[this->HouseHoldPlacesComboBox->ItemIndex] )
  {
   HouseHoldNumber = this->StartingBaseValue + Count;
   break;
  }
 }

 sprintf(TempHouseHoldChar,"%02d",HouseHoldNumber);
 LeftHouseHoldNumber = int(TempHouseHoldChar[0]) - int('0');
 RightHouseHoldNumber = int(TempHouseHoldChar[1]) - int('0');

 Randomize();
 RandNumber = RandomRange(0,9999999);
 sprintf(&IDCode[2],"%07d",RandNumber);

 SumUp = LeftHouseHoldNumber + ( RightHouseHoldNumber * 9 );
 for ( Count = 1 ; Count <= 8 ; ++Count )
       SumUp += ( int(IDCode[Count]) - int('0') ) * ( 9 - Count );

 if ( ( SumUp % 10 ) == 0 )
        CheckSum = 0;
 else
        CheckSum = 10 - ( SumUp % 10 );
 CheckSumChar = char('0') + CheckSum;
 strcat(IDCode,AnsiString(CheckSumChar).c_str());
}

//---------------------------------------------------------------------------

void __fastcall TCheckerForm::VerifyBitBtnClick(TObject *Sender)
{
 if ( this->IDVerifiedLabeledEdit->Text.Length() == 0 )
      return;

 this->IDVerifiedLabeledEdit->Text = this->IDVerifiedLabeledEdit->Text.UpperCase();

 if ( this->IDVerifiedLabeledEdit->Text.Length() != this->IDCodeLength )
 {
  ::MessageBox(GetActiveWindow(),"Ҧr׿~I","~", MB_OK | MB_ICONERROR);
  this->IDVerifiedLabeledEdit->SetFocus();
  return;
 }
 else if ( ! this->VerifyIDFormat(this->IDVerifiedLabeledEdit->Text.c_str() ) )
 {
  ::MessageBox(GetActiveWindow(), AnsiString( this->IDVerifiedLabeledEdit->Text + " Ҧr榡XkIЦAաC" ).c_str() ,"~", MB_OK | MB_ICONERROR);
  this->IDVerifiedLabeledEdit->SetFocus();
  return;
 }
 else if ( ! this->VerifyIDCode(this->IDVerifiedLabeledEdit->Text.c_str() ) )
 {
  ::MessageBox(GetActiveWindow(), AnsiString( this->IDVerifiedLabeledEdit->Text + " ҦrXkIЦAաC" ).c_str() ,"~", MB_OK | MB_ICONERROR);
  this->IDVerifiedLabeledEdit->SetFocus();
  return;
 }
 else
 {
  ::MessageBox(GetActiveWindow(),AnsiString( this->IDVerifiedLabeledEdit->Text + " ҦrXkI" ).c_str() ,"~", MB_OK | MB_ICONERROR);
  this->IDVerifiedLabeledEdit->SetFocus();  
  return;
 }
}
//---------------------------------------------------------------------------

void __fastcall TCheckerForm::GenerateBitBtnClick(TObject *Sender)
{
 char *pNewIDCode;

 try
 {
  pNewIDCode = new char[this->IDCodeLength] + 1; // FOR NULL CHAR
  pNewIDCode = "";
  this->GenerateIDCode(pNewIDCode);
  this->IDGeneratedLabeledEdit->Text = pNewIDCode;
  this->IDVerifiedLabeledEdit->Text = pNewIDCode;
 }
 __finally
 {
  delete pNewIDCode;
 }
}
//---------------------------------------------------------------------------


